diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockGrass.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicGrass.java
similarity index 73%
rename from game/core/src/main/java/net/minecraft/core/block/BlockGrass.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicGrass.java
index e8264b535..1851857df 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockGrass.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicGrass.java
@@ -10,12 +10,14 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
 
-public class BlockGrass extends Block
+public class BlockLogicGrass extends BlockLogic
 {
-    public BlockGrass(String key, String namespaceId, int id, Material material)
+    public final Block<?> dirt;
+    public BlockLogicGrass(Block<?> block, Block<?> dirt)
     {
-        super(key, namespaceId, id, material);
-        setTicking(true);
+        super(block, Material.grass);
+        block.setTicking(true);
+        this.dirt = dirt;
     }
 
     @Override
@@ -31,7 +33,7 @@ public class BlockGrass extends Block
             {
                 return;
             }
-            world.setBlockWithNotify(x, y, z, Blocks.DIRT.id);
+            world.setBlockWithNotify(x, y, z, dirt.id());
         } else
         if(world.getBlockLightValue(x, y + 1, z) >= 9)
         {
@@ -39,9 +41,9 @@ public class BlockGrass extends Block
             int i1 = (y + rand.nextInt(5)) - 3;
             int j1 = (z + rand.nextInt(3)) - 1;
             int k1 = world.getBlockId(l, i1 + 1, j1);
-            if(world.getBlockId(l, i1, j1) == Blocks.DIRT.id && world.getBlockLightValue(l, i1 + 1, j1) >= 4 && Blocks.lightBlock[k1] <= 2)
+            if(world.getBlockId(l, i1, j1) == dirt.id() && world.getBlockLightValue(l, i1 + 1, j1) >= 4 && Blocks.lightBlock[k1] <= 2)
             {
-                world.setBlockWithNotify(l, i1, j1, this.id);
+                world.setBlockWithNotify(l, i1, j1, block.id());
             }
             if (world.getGameRuleValue(GameRules.DO_SEASONAL_GROWTH) && world.getBlockId(x, y + 1, z) == 0 && world.getSeasonManager().getCurrentSeason() != null && world.getSeasonManager().getCurrentSeason().growFlowers && rand.nextInt(256) == 0)
             {
@@ -49,23 +51,23 @@ public class BlockGrass extends Block
                 int r = rand.nextInt(400);
 
                 if (r < 26) {
-                    idToSpawn = Blocks.FLOWER_RED.id;
+                    idToSpawn = Blocks.FLOWER_RED.id();
                 } else if (r < 41) {
-                    idToSpawn = Blocks.FLOWER_YELLOW.id;
+                    idToSpawn = Blocks.FLOWER_YELLOW.id();
                 } else if (r < 60) {
                     Biome biome = world.getBlockBiome(x, y + 1, z);
                     if (biome == Biomes.OVERWORLD_BIRCH_FOREST || biome == Biomes.OVERWORLD_SEASONAL_FOREST){
-                        idToSpawn = Blocks.FLOWER_PINK.id;
+                        idToSpawn = Blocks.FLOWER_PINK.id();
                     } else if (biome == Biomes.OVERWORLD_MEADOW || biome == Biomes.OVERWORLD_BOREAL_FOREST || biome == Biomes.OVERWORLD_SHRUBLAND) {
-                        idToSpawn = Blocks.FLOWER_PURPLE.id;
+                        idToSpawn = Blocks.FLOWER_PURPLE.id();
                     } else if (biome == Biomes.OVERWORLD_FOREST || biome == Biomes.OVERWORLD_SWAMPLAND || biome == Biomes.OVERWORLD_RAINFOREST || biome == Biomes.OVERWORLD_CAATINGA) {
-                        idToSpawn = Blocks.FLOWER_LIGHT_BLUE.id;
+                        idToSpawn = Blocks.FLOWER_LIGHT_BLUE.id();
                     }
                 } else {
                     if(rand.nextInt(8) == 0) {
-                        idToSpawn = Blocks.TALLGRASS_FERN.id;
+                        idToSpawn = Blocks.TALLGRASS_FERN.id();
                     }else {
-                        idToSpawn = Blocks.TALLGRASS.id;
+                        idToSpawn = Blocks.TALLGRASS.id();
                     }
                 }
 
@@ -83,7 +85,7 @@ public class BlockGrass extends Block
             case PICK_BLOCK:
                 return new ItemStack[] { new ItemStack(this) };
             default:
-                return new ItemStack[] { new ItemStack(Blocks.DIRT) };
+                return new ItemStack[] { new ItemStack(dirt) };
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockGravel.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicGravel.java
similarity index 85%
rename from game/core/src/main/java/net/minecraft/core/block/BlockGravel.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicGravel.java
index 09c457898..684c1627b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockGravel.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicGravel.java
@@ -6,12 +6,12 @@ import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
 
-public class BlockGravel extends BlockSand
+public class BlockLogicGravel extends BlockLogicSand
 {
 
-    public BlockGravel(String key, String namespaceId, int id)
+    public BlockLogicGravel(Block<?> block)
     {
-        super(key, namespaceId, id);
+        super(block);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockIce.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicIce.java
similarity index 75%
rename from game/core/src/main/java/net/minecraft/core/block/BlockIce.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicIce.java
index 9844438a9..af17b0cb8 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockIce.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicIce.java
@@ -10,14 +10,14 @@ import net.minecraft.core.world.World;
 
 import java.util.Random;
 
-public class BlockIce extends BlockTransparent
+public class BlockLogicIce extends BlockLogicTransparent
 {
 
-    public BlockIce(String key, String namespaceId, int id)
+    public BlockLogicIce(Block<?> block)
     {
-        super(key, namespaceId, id, Material.ice);
-        friction = 0.98F;
-        setTicking(true);
+        super(block, Material.ice);
+        block.friction = 0.98F;
+        block.setTicking(true);
     }
 
     @Override
@@ -34,22 +34,22 @@ public class BlockIce extends BlockTransparent
     }
 
     @Override
-    public void harvestBlock(World world, Player entityplayer, int x, int y, int z, int meta, TileEntity tileEntity)
+    public void harvestBlock(World world, Player player, int x, int y, int z, int meta, TileEntity tileEntity)
     {
-        super.harvestBlock(world, entityplayer, x, y, z, meta, tileEntity);
+        super.harvestBlock(world, player, x, y, z, meta, tileEntity);
         Material material = world.getBlockMaterial(x, y - 1, z);
         if(material.blocksMotion() || material.isLiquid())
         {
-            world.setBlockWithNotify(x, y, z, Blocks.FLUID_WATER_FLOWING.id);
+            world.setBlockWithNotify(x, y, z, Blocks.FLUID_WATER_FLOWING.id());
         }
     }
 
     @Override
 	public void updateTick(World world, int x, int y, int z, Random rand)
     {
-        if(world.getSavedLightValue(LightLayer.Block, x, y, z) > 11 - Blocks.lightBlock[id])
+        if(world.getSavedLightValue(LightLayer.Block, x, y, z) > 11 - block.lightBlock)
         {
-            world.setBlockWithNotify(x, y, z, Blocks.FLUID_WATER_STILL.id);
+            world.setBlockWithNotify(x, y, z, Blocks.FLUID_WATER_STILL.id());
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockJar.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJar.java
similarity index 77%
rename from game/core/src/main/java/net/minecraft/core/block/BlockJar.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicJar.java
index 28d2458f9..1efef53b4 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockJar.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJar.java
@@ -18,11 +18,12 @@ import org.jetbrains.annotations.NotNull;
 
 import java.util.function.Supplier;
 
-public class BlockJar extends BlockTileEntity {
+public class BlockLogicJar extends BlockLogic {
 
     private final Supplier<Item> itemSupplier;
-    public BlockJar(String key, String namespaceId, int id, @NotNull Supplier<Item> itemSupplier) {
-        super(key, namespaceId, id, Material.glass);
+    public BlockLogicJar(Block<?> block, @NotNull Supplier<Item> itemSupplier) {
+        super(block, Material.glass);
+        block.withEntity(TileEntityFlowerJar::new);
         setBlockBounds(0.3125f, 0, 0.3125f, 1 - 0.3125f, 0.375f, 1 - 0.3125f);
         this.itemSupplier = itemSupplier;
     }
@@ -64,7 +65,7 @@ public class BlockJar extends BlockTileEntity {
                 TileEntityFlowerJar tileEntity = (TileEntityFlowerJar) world.getBlockEntity(x, y, z);
                 int flowerInPot = tileEntity.flowerInPot;
                 int flowerData = tileEntity.flowerData;
-                if (flowerInPot > 0 && hasTag(flowerInPot, BlockTags.PLANTABLE_IN_JAR)) {
+                if (flowerInPot > 0 && Blocks.hasTag(flowerInPot, BlockTags.PLANTABLE_IN_JAR)) {
                     tileEntity.flowerInPot = 0;
                     world.setBlockMetadataWithNotify(x, y, z, 0);
                     world.playSoundAtEntity(player, player, "item.pickup", 1f, 1f);
@@ -74,25 +75,25 @@ public class BlockJar extends BlockTileEntity {
                 }
             }
         } else if (player.getHeldItem().getItem() instanceof ItemBlock) {
-            Block blockInHand = ((ItemBlock) player.getHeldItem().getItem()).getBlock();
-            if (hasTag(blockInHand.id, BlockTags.PLANTABLE_IN_JAR)) {
+            Block<?> blockInHand = ((ItemBlock<?>) player.getHeldItem().getItem()).getBlock();
+            if (Blocks.hasTag(blockInHand.id(), BlockTags.PLANTABLE_IN_JAR)) {
                 TileEntityFlowerJar tileEntity = (TileEntityFlowerJar) world.getBlockEntity(x, y, z);
                 if(world.getBlockMetadata(x, y, z) == 0) {
                     player.getHeldItem().consumeItem(player);
                     world.setBlockMetadataWithNotify(x, y, z, 1);
-                    tileEntity.flowerInPot = blockInHand.id;
+                    tileEntity.flowerInPot = blockInHand.id();
                     tileEntity.flowerData = player.getHeldItem().getMetadata();
-                    world.playBlockSoundEffect(player, x + 0.5f, y + 0.5f, z + 0.5f, this, EnumBlockSoundEffectType.PLACE);
+                    world.playBlockSoundEffect(player, x + 0.5f, y + 0.5f, z + 0.5f, block, EnumBlockSoundEffectType.PLACE);
                     return true;
-                } else if (blockInHand instanceof BlockFlowerStackable && blockInHand == Blocks.getBlock(tileEntity.flowerInPot)) {
+                } else if (blockInHand.getLogic() instanceof BlockLogicFlowerStackable && blockInHand == Blocks.getBlock(tileEntity.flowerInPot)) {
                     final int metadata = tileEntity.flowerData;
-                    final int currentStackCount = BlockFlowerStackable.getStackCount(metadata);
-                    if (currentStackCount >= BlockFlowerStackable.MAX_STACK_COUNT) {
+                    final int currentStackCount = BlockLogicFlowerStackable.getStackCount(metadata);
+                    if (currentStackCount >= BlockLogicFlowerStackable.MAX_STACK_COUNT) {
                         return false;
                     }
 
-                    tileEntity.flowerData = BlockFlowerStackable.setPermanent(BlockFlowerStackable.setStackCount(metadata, currentStackCount + 1), true);
-                    world.playBlockSoundEffect(player, x + 0.5f, y + 0.5f, z + 0.5f, this, EnumBlockSoundEffectType.PLACE);
+                    tileEntity.flowerData = BlockLogicFlowerStackable.setPermanent(BlockLogicFlowerStackable.setStackCount(metadata, currentStackCount + 1), true);
+                    world.playBlockSoundEffect(player, x + 0.5f, y + 0.5f, z + 0.5f, block, EnumBlockSoundEffectType.PLACE);
                     player.getHeldItem().consumeItem(player);
                     return true;
                 }
@@ -126,10 +127,4 @@ public class BlockJar extends BlockTileEntity {
         return false;
     }
 
-    @Override
-    protected TileEntity getNewBlockEntity()
-    {
-        return new TileEntityFlowerJar();
-    }
-
 }
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockJukebox.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJukebox.java
similarity index 85%
rename from game/core/src/main/java/net/minecraft/core/block/BlockJukebox.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicJukebox.java
index f83a6c989..9b1844041 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockJukebox.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJukebox.java
@@ -9,12 +9,13 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
 
-public class BlockJukebox extends BlockTileEntity
+public class BlockLogicJukebox extends BlockLogic
 {
 
-	public BlockJukebox(String key, String namespaceId, int id)
+	public BlockLogicJukebox(Block<?> block)
     {
-        super(key, namespaceId, id, Material.wood);
+        super(block, Material.wood);
+        block.withEntity(TileEntityJukebox::new);
     }
 
     @Override
@@ -56,10 +57,4 @@ public class BlockJukebox extends BlockTileEntity
         TileEntity tileEntity = world.getBlockEntity(x, y, z);
         tileEntity.dropContents(world, x, y, z);
     }
-
-    @Override
-	protected TileEntity getNewBlockEntity()
-    {
-        return new TileEntityJukebox();
-    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLadder.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLadder.java
similarity index 95%
rename from game/core/src/main/java/net/minecraft/core/block/BlockLadder.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicLadder.java
index b477fd781..e6849807b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLadder.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLadder.java
@@ -7,10 +7,10 @@ import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockLadder extends Block {
+public class BlockLogicLadder extends BlockLogic {
 
-	public BlockLadder(String key, String namespaceId, int id) {
-		super(key, namespaceId, id, Material.wood);
+	public BlockLogicLadder(Block<?> block) {
+		super(block, Material.wood);
 	}
 	
 	@Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLamp.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLamp.java
similarity index 84%
rename from game/core/src/main/java/net/minecraft/core/block/BlockLamp.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicLamp.java
index fb75a470b..b14e07bd4 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLamp.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLamp.java
@@ -9,11 +9,11 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 
-public class BlockLamp extends Block implements IPainted {
+public class BlockLogicLamp extends BlockLogic implements IPainted {
     public boolean isActive;
 
-    public BlockLamp(String key, String namespaceId, int id, boolean isActivated) {
-        super(key, namespaceId, id, Material.stone);
+    public BlockLogicLamp(Block<?> block, boolean isActivated) {
+        super(block, Material.stone);
         isActive = isActivated;
     }
 
@@ -26,9 +26,9 @@ public class BlockLamp extends Block implements IPainted {
         final boolean hasSignal = world.hasDirectSignal(x, y, z) || world.hasNeighborSignal(x, y, z);
 
         if (hasSignal && !isActive) {
-            world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_ACTIVE.id, world.getBlockMetadata(x, y, z));
+            world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_ACTIVE.id(), world.getBlockMetadata(x, y, z));
         } else if (!hasSignal && isActive) {
-            world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_IDLE.id, world.getBlockMetadata(x, y, z));
+            world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_IDLE.id(), world.getBlockMetadata(x, y, z));
         }
     }
 
@@ -37,9 +37,9 @@ public class BlockLamp extends Block implements IPainted {
         final boolean hasSignal = world.hasDirectSignal(x, y, z) || world.hasNeighborSignal(x, y, z);
 
         if (hasSignal && !isActive) {
-            world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_ACTIVE.id, world.getBlockMetadata(x, y, z));
+            world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_ACTIVE.id(), world.getBlockMetadata(x, y, z));
         } else if (!hasSignal && isActive) {
-            world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_IDLE.id, world.getBlockMetadata(x, y, z));
+            world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_IDLE.id(), world.getBlockMetadata(x, y, z));
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLanternFirefly.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLanternFirefly.java
similarity index 88%
rename from game/core/src/main/java/net/minecraft/core/block/BlockLanternFirefly.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicLanternFirefly.java
index a68da71e2..f6eb75ee8 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLanternFirefly.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLanternFirefly.java
@@ -17,14 +17,14 @@ import org.jetbrains.annotations.NotNull;
 import java.util.Random;
 import java.util.function.Supplier;
 
-public class BlockLanternFirefly extends Block{
+public class BlockLogicLanternFirefly extends BlockLogic {
     public static final int MASK_HANGING = 0b0000_0001;
     public static final int MASK_ANGLED = 0b0000_0010;
     private final Supplier<Item> itemSupplier;
     private final MobFireflyCluster.FireflyColor color;
 
-    public BlockLanternFirefly(String key, String namespaceId, int id, MobFireflyCluster.FireflyColor colour, @NotNull Supplier<Item> itemSupplier) {
-        super(key, namespaceId, id, Material.glass);
+    public BlockLogicLanternFirefly(Block<?> block, MobFireflyCluster.FireflyColor colour, @NotNull Supplier<Item> itemSupplier) {
+        super(block, Material.glass);
         this.color = colour;
         this.itemSupplier = itemSupplier;
         setBlockBounds(0.3125f, 0, 0.3125f, 1 - 0.3125f, 0.5f, 1 - 0.3125f);
@@ -75,7 +75,7 @@ public class BlockLanternFirefly extends Block{
     }
     @Override
     public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
-        if ((side == Side.BOTTOM || (side != Side.TOP && yPlaced >= 0.5d)) && (world.isBlockNormalCube(x, y+1, z) || Block.hasTag(world.getBlockId(x, y + 1, z), BlockTags.CAN_HANG_OFF))){
+        if ((side == Side.BOTTOM || (side != Side.TOP && yPlaced >= 0.5d)) && (world.isBlockNormalCube(x, y+1, z) || Blocks.hasTag(world.getBlockId(x, y + 1, z), BlockTags.CAN_HANG_OFF))){
             world.setBlockMetadataWithNotify(x, y, z, MASK_HANGING);
             return;
         }
@@ -83,7 +83,7 @@ public class BlockLanternFirefly extends Block{
             world.setBlockMetadataWithNotify(x, y, z, 0);
             return;
         }
-        if(world.isBlockNormalCube(x, y+1, z) || Block.hasTag(world.getBlockId(x, y + 1, z), BlockTags.CAN_HANG_OFF))
+        if(world.isBlockNormalCube(x, y+1, z) || Blocks.hasTag(world.getBlockId(x, y + 1, z), BlockTags.CAN_HANG_OFF))
         {
             world.setBlockMetadataWithNotify(x, y, z, MASK_HANGING);
         } else world.setBlockMetadataWithNotify(x, y, z, 0);
@@ -92,7 +92,7 @@ public class BlockLanternFirefly extends Block{
     @Override
     public boolean canPlaceBlockAt(World world, int x, int y, int z)
     {
-        if(world.isBlockNormalCube(x, y + 1, z) || Block.hasTag(world.getBlockId(x, y + 1, z), BlockTags.CAN_HANG_OFF)) {
+        if(world.isBlockNormalCube(x, y + 1, z) || Blocks.hasTag(world.getBlockId(x, y + 1, z), BlockTags.CAN_HANG_OFF)) {
             return true;
         }
 
@@ -128,7 +128,7 @@ public class BlockLanternFirefly extends Block{
     {
         int meta = world.getBlockMetadata(x, y, z);
         if((meta & MASK_HANGING) != 0) {
-            return world.isBlockNormalCube(x, y + 1, z) || Block.hasTag(world.getBlockId(x, y + 1, z), BlockTags.CAN_HANG_OFF);
+            return world.isBlockNormalCube(x, y + 1, z) || Blocks.hasTag(world.getBlockId(x, y + 1, z), BlockTags.CAN_HANG_OFF);
         }
 
         return world.canPlaceOnSurfaceOfBlock(x, y - 1, z);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLayerBase.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerBase.java
similarity index 58%
rename from game/core/src/main/java/net/minecraft/core/block/BlockLayerBase.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerBase.java
index f6125a815..15424f0a8 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLayerBase.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerBase.java
@@ -5,22 +5,16 @@ import net.minecraft.core.item.block.ItemBlockLayer;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 
-import java.util.function.Supplier;
-
-public abstract class BlockLayerBase extends Block
+public abstract class BlockLogicLayerBase extends BlockLogic
 {
-    private Supplier<Integer> idSupplier = () -> -1;
+    public Block<?> fullBlock = null;
 	
-	public BlockLayerBase(String key, String namespaceId, int id, Material material)
+	public BlockLogicLayerBase(Block<?> block, Block<?> fullBlock, Material material)
     {
-        super(key, namespaceId, id, material);
+        super(block, material);
         setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.125F, 1.0F);
-        setBlockItem(() -> new ItemBlockLayer(this));
-    }
-    public BlockLayerBase setFullBlockID(Supplier<Integer> idSupplier)
-    {
-    	this.idSupplier = idSupplier;
-    	return this;
+        block.setBlockItem(() -> new ItemBlockLayer<>((Block<? extends BlockLogicLayerBase>) block));
+        this.fullBlock = fullBlock;
     }
 
     @Override
@@ -42,7 +36,4 @@ public abstract class BlockLayerBase extends Block
         float f = (float)(2 * (1 + l)) / 16F;
         return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, f, 1.0F);
     }
-    public int getFullBlockID() {
-        return idSupplier.get();
-    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLayerLeaves.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerLeaves.java
similarity index 80%
rename from game/core/src/main/java/net/minecraft/core/block/BlockLayerLeaves.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerLeaves.java
index d28f0f521..6c7f4960d 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLayerLeaves.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerLeaves.java
@@ -3,6 +3,7 @@ package net.minecraft.core.block;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.block.ItemBlockLayerLeaves;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.phys.AABB;
@@ -10,15 +11,16 @@ import net.minecraft.core.world.WorldSource;
 
 import java.util.Random;
 
-public class BlockLayerLeaves extends BlockLayerBase
+public class BlockLogicLayerLeaves extends BlockLogicLayerBase
 {
     public static final int MASK_PERMANENT = 0b1000_0000;
 
-	public BlockLayerLeaves(String key, String namespaceId, int id, Material material)
+	public BlockLogicLayerLeaves(Block<?> block, Block<?> fullBlock, Material material)
     {
-        super(key, namespaceId, id, material);
+        super(block, fullBlock, material);
         setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.125F, 1.0F);
-        setTicking(true);
+        block.setTicking(true);
+        block.setBlockItem(() -> new ItemBlockLayerLeaves<>((Block<? extends BlockLogicLayerLeaves>) block));
     }
 
     @Override
@@ -32,13 +34,13 @@ public class BlockLayerLeaves extends BlockLayerBase
     	int myMetadata = world.getBlockMetadata(x, y, z);
     	if (myMetadata == 0x7) return;
     	
-    	boolean posXValid = (world.isBlockOpaqueCube(x + 1, y, z)) || (world.getBlockId(x + 1, y, z) == this.id && world.getBlockMetadata(x + 1, y, z) >= myMetadata);
+    	boolean posXValid = (world.isBlockOpaqueCube(x + 1, y, z)) || (world.getBlockId(x + 1, y, z) == block.id() && world.getBlockMetadata(x + 1, y, z) >= myMetadata);
     	if (!posXValid) return;
-    	boolean posZValid = (world.isBlockOpaqueCube(x, y, z + 1)) || (world.getBlockId(x, y, z + 1) == this.id && world.getBlockMetadata(x, y, z + 1) >= myMetadata);
+    	boolean posZValid = (world.isBlockOpaqueCube(x, y, z + 1)) || (world.getBlockId(x, y, z + 1) == block.id() && world.getBlockMetadata(x, y, z + 1) >= myMetadata);
     	if (!posZValid) return;
-    	boolean negXValid = (world.isBlockOpaqueCube(x - 1, y, z)) || (world.getBlockId(x - 1, y, z) == this.id && world.getBlockMetadata(x - 1, y, z) >= myMetadata);
+    	boolean negXValid = (world.isBlockOpaqueCube(x - 1, y, z)) || (world.getBlockId(x - 1, y, z) == block.id() && world.getBlockMetadata(x - 1, y, z) >= myMetadata);
     	if (!negXValid) return;
-    	boolean negZValid = (world.isBlockOpaqueCube(x, y, z - 1)) || (world.getBlockId(x, y, z - 1) == this.id && world.getBlockMetadata(x, y, z - 1) >= myMetadata);
+    	boolean negZValid = (world.isBlockOpaqueCube(x, y, z - 1)) || (world.getBlockId(x, y, z - 1) == block.id() && world.getBlockMetadata(x, y, z - 1) >= myMetadata);
     	if (!negZValid) return;
     	
     	world.setBlockMetadata(x, y, z, myMetadata + 1);
@@ -49,7 +51,7 @@ public class BlockLayerLeaves extends BlockLayerBase
 	public boolean canPlaceBlockAt(World world, int x, int y, int z)
     {
         int l = world.getBlockId(x, y - 1, z);
-        if(l == 0 || (!Blocks.blocksList[l].isSolidRender() && !(Blocks.blocksList[l] instanceof BlockLeavesBase)))
+        if(l == 0 || (!Blocks.blocksList[l].isSolidRender() && !(Blocks.blocksList[l].getLogic() instanceof BlockLogicLeavesBase)))
         {
         	return false;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLayerSlate.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSlate.java
similarity index 80%
rename from game/core/src/main/java/net/minecraft/core/block/BlockLayerSlate.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSlate.java
index 3305b34b2..1fcff0f15 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLayerSlate.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSlate.java
@@ -7,11 +7,11 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
 
 
-public class BlockLayerSlate extends BlockLayerBase
+public class BlockLogicLayerSlate extends BlockLogicLayerBase
 {
-	public BlockLayerSlate(String key, String namespaceId, int id, Material material)
+	public BlockLogicLayerSlate(Block<?> block, Block<?> fullBlock, Material material)
 	{
-		super(key, namespaceId, id, material);
+		super(block, fullBlock, material);
 	}
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLayerSnow.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSnow.java
similarity index 81%
rename from game/core/src/main/java/net/minecraft/core/block/BlockLayerSnow.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSnow.java
index b96913312..081207a22 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLayerSnow.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSnow.java
@@ -10,14 +10,14 @@ import net.minecraft.core.block.material.Material;
 
 import java.util.Random;
 
-public class BlockLayerSnow extends BlockLayerBase
+public class BlockLogicLayerSnow extends BlockLogicLayerBase
 {
 
-	public BlockLayerSnow(String key, String namespaceId, int id, Material material)
+	public BlockLogicLayerSnow(Block<?> block, Block<?> fullBlock, Material material)
     {
-        super(key, namespaceId, id, material);
+        super(block, fullBlock, material);
         setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.125F, 1.0F);
-        setTicking(true);
+        block.setTicking(true);
     }
 
     public void accumulate(World world, int x, int y, int z)
@@ -25,13 +25,13 @@ public class BlockLayerSnow extends BlockLayerBase
     	int myMetadata = world.getBlockMetadata(x, y, z);
     	if (myMetadata == 0x7) return;
     	
-    	boolean posXValid = (world.isBlockOpaqueCube(x + 1, y, z)) || (world.getBlockId(x + 1, y, z) == this.id && world.getBlockMetadata(x + 1, y, z) >= myMetadata);
+    	boolean posXValid = (world.isBlockOpaqueCube(x + 1, y, z)) || (world.getBlockId(x + 1, y, z) == block.id() && world.getBlockMetadata(x + 1, y, z) >= myMetadata);
     	if (!posXValid) return;
-    	boolean posZValid = (world.isBlockOpaqueCube(x, y, z + 1)) || (world.getBlockId(x, y, z + 1) == this.id && world.getBlockMetadata(x, y, z + 1) >= myMetadata);
+    	boolean posZValid = (world.isBlockOpaqueCube(x, y, z + 1)) || (world.getBlockId(x, y, z + 1) == block.id() && world.getBlockMetadata(x, y, z + 1) >= myMetadata);
     	if (!posZValid) return;
-    	boolean negXValid = (world.isBlockOpaqueCube(x - 1, y, z)) || (world.getBlockId(x - 1, y, z) == this.id && world.getBlockMetadata(x - 1, y, z) >= myMetadata);
+    	boolean negXValid = (world.isBlockOpaqueCube(x - 1, y, z)) || (world.getBlockId(x - 1, y, z) == block.id() && world.getBlockMetadata(x - 1, y, z) >= myMetadata);
     	if (!negXValid) return;
-    	boolean negZValid = (world.isBlockOpaqueCube(x, y, z - 1)) || (world.getBlockId(x, y, z - 1) == this.id && world.getBlockMetadata(x, y, z - 1) >= myMetadata);
+    	boolean negZValid = (world.isBlockOpaqueCube(x, y, z - 1)) || (world.getBlockId(x, y, z - 1) == block.id() && world.getBlockMetadata(x, y, z - 1) >= myMetadata);
     	if (!negZValid) return;
     	
     	world.setBlockMetadata(x, y, z, myMetadata + 1);
@@ -42,7 +42,7 @@ public class BlockLayerSnow extends BlockLayerBase
 	public boolean canPlaceBlockAt(World world, int x, int y, int z)
     {
         int l = world.getBlockId(x, y - 1, z);
-        if(l == 0 || (!Blocks.blocksList[l].isSolidRender() && !(Blocks.blocksList[l] instanceof BlockLeavesBase)))
+        if(l == 0 || (!Blocks.blocksList[l].isSolidRender() && !(Blocks.blocksList[l].getLogic() instanceof BlockLogicLeavesBase)))
         {
         	return false;
         }
